package org.springblade.device.feign;

import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.tool.utils.Func;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import org.springblade.device.entity.IotDeviceDetail;
import org.springblade.device.vo.IotDeviceDetailVO;
import org.springblade.device.wrapper.IotDeviceDetailWrapper;
import org.springblade.device.service.IIotDeviceDetailService;
import org.springblade.core.boot.ctrl.BladeController;
import java.util.List;
/**
 *  client
 *
 * @author lianghanqiang
 * @since 2021-04-19
 */

@AllArgsConstructor
@RestController
@RequestMapping("/feign/iotdevicedetail")

public class IotDeviceDetailClient implements IIotDeviceDetailClient {

    private final IIotDeviceDetailService iotDeviceDetailService;

        /**
     * 详情
     */
    @Override
    @GetMapping("/detail")
    public IotDeviceDetailVO detail(@SpringQueryMap IotDeviceDetail iotDeviceDetail) {
        IotDeviceDetail detail = iotDeviceDetailService.getOne(Condition.getQueryWrapper(iotDeviceDetail));
        return IotDeviceDetailWrapper.build().entityVO(detail);
        }

    /**
     * 查询
     */
    @Override
    @GetMapping("/list")
    public List<IotDeviceDetailVO> list(@SpringQueryMap IotDeviceDetail iotDeviceDetail) {
        return IotDeviceDetailWrapper.build().listVO(iotDeviceDetailService.list(Condition.getQueryWrapper(iotDeviceDetail)));
        }



    /**
     * 新增
     */
    @Override
    @PostMapping("/save")
    public boolean save(@Valid @RequestBody IotDeviceDetail iotDeviceDetail) {
        return iotDeviceDetailService.save(iotDeviceDetail);
        }

    /**
     * 修改
     */
    @Override
    @PostMapping("/update")
    public boolean update(@Valid @RequestBody IotDeviceDetail iotDeviceDetail) {
        return iotDeviceDetailService.updateById(iotDeviceDetail);
        }

    /**
     * 新增或修改
     */
    @Override
    @PostMapping("/submit")
    public boolean submit(@Valid @RequestBody IotDeviceDetail iotDeviceDetail) {
        return iotDeviceDetailService.saveOrUpdate(iotDeviceDetail);
        }


    /**
     * 删除
     */
    @Override
    @PostMapping("/remove")
    public boolean remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
        return iotDeviceDetailService.deleteLogic(Func.toLongList(ids));
        }


}
